import React from 'react';
import { connect } from 'react-redux';
import { bindActionCreators } from 'redux';
import { getCategoryRequest } from '../../../actions/admin/category/getCategory';
import CreateTopic from './CreateTopic';
import { createTopicsRequest } from '../../../actions/admin/test/createTopics';
import { createTestRequest } from '../../../actions/admin/test/createTest';
import { myUserRequest } from '../../../actions/admin/meUser'




class CreateTest extends React.Component {
    state = {
        categoryId: null
    }

    componentDidMount() {
        const { getCategoryRequest, myUserRequest } = this.props;
        getCategoryRequest()
    }

    onClick = (event) => {
        this.setState({ categoryId: event.target.value })
    }




    render() {
        const { category: { data }, createTopicsRequest, createTestRequest, topicId:{ topic } } = this.props;
        const { categoryId } = this.state
        const { onClick } = this;


        console.log(topic)

        return (
            <div className=" profile-page p-4 d-flex flex-row font-ci">
                <div className='w-50 p-3 bg-gradient border rounded'  >
                    <h3 className="text-white font-ci">Select category for creating tests</h3>
                    <select class="custom-select bg-mist bg-mist-op text-white mt-3 mb-3" onChange={onClick} value={categoryId}>
                        <option selected>Open this Category menu</option>
                        {
                            data && data.map(mass => <option key={mass._id} value={mass._id}>{mass.name}</option>)

                        }
                    </select>
                    <CreateTopic categoryId={categoryId} topic={topic} actions={{ createTopicsRequest, createTestRequest }} ></CreateTopic>
                </div>
                <div>
                    ffff
            </div>
            </div>

        )
    }

}

const
    mapStateToProps = state => ({
        myUser: state.myUser,
        category: state.category,
        topicId: state.topicId
    });

const mapDispatchToProps = dispatch => bindActionCreators({ getCategoryRequest, createTopicsRequest, createTestRequest, myUserRequest }, dispatch);

export default connect(mapStateToProps, mapDispatchToProps)(CreateTest);