import React from 'react';
import { CSSTransition, TransitionGroup } from 'react-transition-group';
import PropagateLoader from 'react-spinners/PropagateLoader';

import CreateCategoryForm from "./CreateCategoryForm";
import ChangeCategory from "./ChangeCategory";
import DeleteCategory from './DeleteCategory';

import store from './../../../state';


class GetCategory extends React.Component {

    state = {
        click: false,
        clicked: false,
        categorys: { // categorIEs
            id: null,
            names: null
        },
        chpic: false,
        massCategory: null,
    }
    componentDidMount() {
        const { category } = this.props;
        this.setState({ massCategory: category.data })
    }

    handelClick = () => {
        const { data, isFlag } = this.props
        //!this.state.click || !isFlag ? console.log(isFlag) : this.setState({ massCategory: this.state.massCategory.concat(data) })
        //this.setState((prevState) => ({ click: !prevState.click }));
        // data && this.setState(prevState => {
        //     console.log('----- Prev State', prevState);
        //     this.setState({ massCategory: this.state.massCategory.concat(data) })
        // })
    }
    cclics = () => { //cliCKS
        this.setState((prevState) => ({ click: !prevState.click }));

    }
    deleteClick = () => {
        const { massCategory, categorys: { id } } = this.state;
        for (let key in massCategory) {
            if (massCategory[key]._id == id) {
                delete massCategory[key]
                // console.log('NET' )
            }
            else {
                // console.log("null")
            }
        }
        this.setState((prevState) => ({ clicked: !prevState.clicked }))
    }

    componentWillReceiveProps(nextProps) {
        console.log(nextProps)
        const { data, isFlag, actions: { changeCategoryRequest }, changeCategory } = nextProps;
        const { massCategory } = this.state;
        console.log(data)

        if (data) {
            this.setState(prevState => {
                console.log('----- SET STATE INTO DID UPDATE', prevState);
                this.setState({ massCategory: this.state.massCategory.concat(data) });
                store.dispatch({
                    type: 'wtfCreate'
                })
            })
        }
        if (changeCategory.data) {
            for (const key in massCategory) {
                if (massCategory[key]._id === changeCategory.data._id) {
                    this.setState(prevState => {
                        const categoriesArray = prevState.massCategory.slice();
                        categoriesArray.splice(key, 1, changeCategory.data);

                        return {
                            massCategory: categoriesArray
                        }
                    })
                    break;
                }
            }
            store.dispatch({
                type: 'wtfUpdate'
            })
        }

        return true
    }

    onClicked = ({ mass: { _id, name } }) => {
        this.setState({ categorys: { id: _id, name: name } })
        this.setState((prevState) => ({ clicked: !prevState.clicked }))
    }

    render() {
        const { actions: { createCategoryRequest, changeCategoryRequest }, data } = this.props;
        const { category } = this.props;
        const { handelClick, onClicked, deleteClick, changeCategoryClick } = this;
        const { click, categorys, newCategory, massCategory, clicked } = this.state;
        console.log(this.state)

        return (
            <div>
                <div className="container w-100 h-auto  bg-stone  bg-mist-border">
                    {
                        massCategory !== null
                            ?
                            massCategory.map(mass =>
                                <div className="btn " key={mass.id}>
                                    <button class="btn btn-secondary font-ci font-ci-bold text-light bg-mist " onClick={onClicked.bind(null, { mass })} type="button" id={mass.id} key={mass.id} >
                                        {mass.name}
                                    </button>
                                </div>

                            )
                            :
                            <PropagateLoader />
                    }
                    <div>
                        {
                            click
                                ?
                                <CreateCategoryForm newCategory={newCategory} actions={{ createCategoryRequest }} handlers={{ handelClick }}></CreateCategoryForm>
                                :
                                <button type='button' onClick={this.cclics}>Create Category</button>
                        }
                    </div>

                </div>
                {
                    clicked
                        ?
                        <React.Fragment>
                            <ChangeCategory actions={{ changeCategoryRequest }} categorys={categorys} handlers={{ changeCategoryClick }}></ChangeCategory>
                            <DeleteCategory categorys={categorys} handlers={{ deleteClick }} ></DeleteCategory>
                        </React.Fragment>
                        :
                        null
                }
            </div>
        )
    }

}


export default GetCategory;