import React from 'react';
import { connect } from 'react-redux';
import { bindActionCreators } from 'redux'
import { changeUserRequest } from '../../../actions/admin/user/changeUser';
import formInput from '../../common/formInput';
import { Field, reduxForm } from 'redux-form';


class ChangeUsers extends React.Component {


    submit = ({ name, email, newPassword, confirmPassword }) => {
        const { action: { changeUserRequest }, initialValues: { _id } } = this.props
        console.log(name, email, newPassword, confirmPassword);
        changeUserRequest({
            name,
            email,
            newPassword,
            confirmPassword,
            _id
        })
    }



    render() {
        const { initialValues, handleSubmit } = this.props;
        const { submit } = this
        console.log(initialValues)

        return (
            <div>

                <form onSubmit={handleSubmit(submit)}>
                    <Field name="name" type="name" component={formInput} />
                    <Field name="email" type="email" component={formInput} />
                    <Field name="newPassword" type="password" placeholder="Enter login" component={formInput} />
                    <Field name="confirmPassword" type="password" placeholder="Enter login" component={formInput} />
                    <button>Change</button>
                </form >
            </div>

        )
    }

}



export default reduxForm({
    form: "ChangeUserForm",
    enableReinitialize: true
})(ChangeUsers)