import React from 'react';
import { Link } from "react-router-dom";
import { connect } from 'react-redux';
import { bindActionCreators } from 'redux';

import * as routes from '../../constants/routes'
import logOut from './../../actions/auth/logOut';

class Header extends React.Component {
    handleLogOut = () => {
        const { logOut } = this.props;
        logOut()
        //TODO: REDIRECT
    }

    render() {
        return (
            <nav class="navbar navbar-expand-lg navbar-expand-lg bg-gradient1 p-4 position-absolute w-100 ">
                <Link to={routes.LANDING} class="navbar-brand font-label text-af" href="#">Test.io</Link>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon" />
                </button>

                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <ul class="navbar-nav mr-auto">
                        <li class="nav-item active">
                            <Link onClick={this.handleClick} class="nav-link text-shadow font-ci font-ci-bold" to={routes.HOME}>Home <span class="sr-only">(current)</span></Link>
                        </li>
                        <li class="nav-item">
                            <Link onClick={this.handleClick} class="nav-link text-shadow font-ci font-ci-bold" to={routes.PROFILE}>Profile</Link>
                        </li>
                        <li class="nav-item">
                            <Link onClick={this.handleClick} class="nav-link text-shadow font-ci font-ci-bold " to={routes.TESTS}>Tests</Link>
                        </li>
                        <li class="nav-item">
                            <Link onClick={this.handleClick} class="nav-link text-shadow font-ci font-ci-bold " to={routes.CATEGORIES}>Catigories</Link>

                        </li>
                        
                        <li class="nav-item dropdown">

                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                Dropdown
                                </a>
                            <div class="dropdown-menu" aria-labelledby="navbarDropdown">
                            <Link to={routes.DELETE_USER} className="nav-link text-secondary">Delete User</Link>
                                <Link to={routes.CREATE_TEST} className="nav-link text-secondary">Create Test</Link>
                                <Link to={routes.CHANGE_TEST} className="nav-link text-secondary">Change Test</Link>
                                
                                <Link to={routes.CREATE_CATEGORY} className="nav-link text-secondary">Create Category</Link>

                                <div class="dropdown-divider"></div>
                                <a class="nav-link text-secondary" href="#">Something else here</a>
                            </div>
                        </li>

                    </ul>

                    <div className="">
                        <Link to={routes.SIGN_IN}>
                            <button className="btn  btn-outline-light bg-stone">Sign In</button>
                        </Link>
                        <Link to={routes.SIGN_UP}>
                            <button className="btn  btn-outline-light ml-2 bg-stone">Sign Up</button>

                        </Link>
                        <button onClick={this.handleLogOut} className="btn btn-outline-primary">Log Out</button>
                    </div>
                </div>
            
            </nav>
        )
    }
}

const mapStateToProps = state => ({
    state: state.logOut
});
const mapDispatchToProps = dispatch => bindActionCreators({ logOut }, dispatch)

export default connect(mapStateToProps, mapDispatchToProps)(Header);